/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package input_functions;

import application.Player;
import application.Team;
import java.sql.ResultSet;
import java.util.ArrayList;

/**
 *
 * @author Greg
 */
public class DataFeed {

    public static void createGameEventTable(SqlWriter sql) throws Exception {
        sql.statement.executeUpdate("CREATE  TABLE `hoop_tactics`.`game_event` ("
                + "  `game_event_id` INT(3) NOT NULL AUTO_INCREMENT ,"
                + "  `event_name` VARCHAR(30) NULL ,"
                + "  PRIMARY KEY (`game_event_id`) );");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('made_layup');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('missed_layup');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('made_jumper');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('missed_jumper');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('made_three');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('missed_three');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('made_ft');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('missed_ft');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('reb_d');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('reb_o');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('personal_foul');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('steal');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('block');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('turnover');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('sub_in');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('sub_out');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('timeout_short');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('timeout_long');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('halftime');");
        sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`game_event` (`event_name`) VALUES ('overtime_break');");
    }

    public static ArrayList<Player> getPlayer(ArrayList<String> list, SqlWriter sql) throws Exception {
        System.out.println("Executing getPlayer...");
        ArrayList<Player> pList = new ArrayList<Player>();
        ArrayList<String> sList = new ArrayList<String>();
        ArrayList<Team> teamSet = new ArrayList<Team>();
        try {
            ResultSet rSet = sql.statement.executeQuery("SELECT * FROM `hoop_tactics`.`team`;");
            rSet.first();
            while (!rSet.isAfterLast()) {
                teamSet.add(new Team(rSet.getInt(1), rSet.getString(2)));
                rSet.next();
            }
            for (Team t : teamSet) {
                t.printTeam();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        int teamNo = 0;
        for (String s : list) {
            int index = Integer.valueOf(String.valueOf(s.charAt(s.length() - 2))).intValue();
            s = s.trim();
            if ((s.endsWith("~2~") || s.endsWith("~1~")) && !s.endsWith("~1~  ~2~")) {
                if (s.contains("VISITORS: ")) {
                    s = s.substring(23);
                } else if (s.contains("HOME TEAM: ")) {
                    s = s.substring(24);
                }
                for (Team t : teamSet) {
                    if (s.matches("^Whitman.*")) {
                        s = "Whitman College";
                    }
                    if (s.matches("^Lewis\\s.*")) {
                        s = "Lewis and Clark";
                    }
                    if (s.matches("^" + t.team_name + ".*")) {
                        teamNo = t.team_id;
                    }
                    if (s.matches("^Pacific.*")) {
                        if (!s.matches("^Pacific\\sLutheran.*")) {
                            teamNo = 16;
                        }
                    }
                }
            }
            if (index == 5) {
                sList.add(s);
                boolean y = false;
                String[] x = s.substring(16, 37).split(" ", 2);
                if (x[0].substring(x[0].length() - 1).compareTo(",") == 0) {
                    x[0] = x[0].substring(0, x[0].length() - 1);
                }
                x[1] = x[1].replaceAll("\\.", "").trim();
                if (s.substring(37, 38).compareTo("*") == 0) {
                    y = true;
                }
                boolean playerInList = false;
                if (teamNo == 3) {
                    for (Player p : pList) {
                        if ((p.number.compareTo("3") == 0 && (p.number.compareTo(s.substring(13, 15)) == 0) //Remove duplicate players while capturing all legit ones
                                || (p.last.compareTo(x[1]) == 0  && p.first.compareTo(x[0]) == 0))){ 
                                //|| (p.last.compareTo(x[0]) == 0 && p.first.compareTo(x[1]) == 0))) {
                            playerInList = true;
                            break;
                        }
                    }
                }
                if (!playerInList) {
                    pList.add(new Player(s.substring(13, 15), x[0], x[1], y, teamNo));
                    //pList.get(pList.size() - 1).printPlayer();
                }
            }
        }
        System.out.println("getPlayer Complete.");
        return pList;
    }

    public static ArrayList<String> getTeam(ArrayList<String> list) {
        System.out.println("Executing getTeam...");
        ArrayList<String> data = new ArrayList<String>();
        boolean inList = false;
        for (String s : list) {
            inList = false;
            if (s.endsWith("~1~  ~2~")) {
                String[] temp = s.replaceAll("&amp;", "and").split("TIME", 2);
                temp[0] = temp[0].trim().replaceAll("\\d\\d\\D\\d\\d\\D\\d\\d-2nd HOME TEAM: ", "").replaceAll("\\d\\d\\D\\d\\d\\D\\d\\d-1st HOME TEAM: ", "").replaceAll("\\d\\d\\D\\d\\d\\D\\d\\d-OT  HOME TEAM: ", "").trim();
                temp[1] = temp[1].replaceAll("   SCORE  MAR  VISITORS: ", "").replaceAll("~\\d~", "").trim();
                for (String a : data) {
                    if (temp[0].compareTo("Whitman") == 0) {
                        temp[0] = "Whitman College";
                    }
                    if (a.compareTo(temp[0]) == 0) {
                        inList = true;
                        break;
                    }
                }
                if (!inList) {
                    data.add(temp[0]);
                }
                inList = false;
                for (String a : data) {
                    if (temp[1].compareTo("Whitman") == 0) {
                        temp[1] = "Whitman College";
                    }
                    if (a.compareTo(temp[1]) == 0) {
                        inList = true;
                        break;
                    }
                }
                if (!inList) {
                    data.add(temp[1]);
                }
            }
        }
        System.out.println("getTeam Complete.");
        return data;
    }

    public static ArrayList<String> getDate(ArrayList<String> list) {
        System.out.println("Executing getDate...");
        ArrayList<String> dates = new ArrayList<String>();
        for (String s : list) {
            dates.add(s.substring(0, 8));
        }
        System.out.println("getDate Complete.");
        return dates;
    }

    public static ArrayList<Player> noPlayerDuplicates(ArrayList<Player> pList) {
        int i = 0;
        while (i < pList.size()) {
            int current = i;
            int comparitor = i;
            while (comparitor < pList.size()) {
                if (pList.get(current).compareTo(pList.get(comparitor))) {
                    pList.remove(comparitor);
                    comparitor = current;
                }
                comparitor++;
            }
            i++;
        }
        return pList;
    }

    public static void clean(SqlWriter sql) throws Exception {
        try {
            sql.statement.executeUpdate("DROP  TABLE `hoop_tactics`.`team`;");
            sql.statement.executeUpdate("DROP  TABLE `hoop_tactics`.`player`;");
            sql.statement.executeUpdate("DROP  TABLE `hoop_tactics`.`game_event`;");
        } finally {
        }
    }

    public static void main(String[] args) throws Exception {
        Parser p = new Parser();
        p.initializeInputFeeder();
        int size = p.initializeRegexFeeder();
        p.removeBlock();
        p.addPeriod();
        SqlWriter sql = new SqlWriter();
        //Parser.printArrayList(p.data);
        //DataFeed.getPlayer(p.data, sql);
        //DataFeed.clean(sql);
        sql.statement.executeUpdate("CREATE  TABLE `hoop_tactics`.`team` ("
                + "  `team_id` INT(3) NOT NULL AUTO_INCREMENT ,"
                + "  `team_name` VARCHAR(30) NULL ,"
                + "  PRIMARY KEY (`team_id`) );");
        for (String s : DataFeed.getTeam(p.data)) {
            sql.statement.executeUpdate("INSERT INTO `hoop_tactics`.`team` (`team_name`) VALUES ('" + s + "');");
        }
        DataFeed.getPlayer(p.data, sql);

        /*
        sql.statement.executeUpdate("CREATE  TABLE `hoop_tactics`.`Dates` "
        + "(`date_id` INT ZEROFILL UNSIGNED NOT NULL AUTO_INCREMENT , "
        + "`day` DATE NULL , PRIMARY KEY (`date_id`) );");
        sql.statement.exeuteUpdate();
         * 
         */
    }
}
