/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package input_functions;

import application.Game;
import java.util.ArrayList;
import java.util.regex.Pattern;
import java.util.regex.Matcher;
import application.Player;

/**
 *
 * @author Greg
 */
public class Parser {

    public ArrayList<String> data;
    public ArrayList<String> originalData;

    public Parser() {
        data = new ArrayList<String>();
        originalData = new ArrayList<String>();
    }

    /*
     * Removes all elements of an ArrayList<String> that match 
     */
    public void removeOn(String offending, ArrayList<String> list) {
        boolean done = false;
        for (int i = 0; i < list.size(); i++) {
            if (list.get(i).contains(offending)) {
                list.remove(i);
                done = false;
                break;
            } else {
                done = true;
            }
        }
        if (!done) {
            removeOn(offending, list);
        }
    }

    public void refreshData() {
        data.clear();
        for (String s : originalData) {
            data.add(s);
        }
    }

    public void initializeInputFeeder() {
        System.out.println("Initialiing Web Crawler...");
        for (int i = 0; i < 27; i++) {
            try {
                data = InputFeeder.webIn("http://www.whitman.edu/athletics/Recaps11-12/wbb1112-game" + i + ".htm", data);
                for (String s : data) {
                    originalData.add(s);
                }
            } catch (Exception e) {
                break;
            }
        }
        System.out.println("Web Crawler Built.");
    }

    public void addPeriod() {
        System.out.println("Adding Period Data to list...");
        String per = "1st ";
        String day = "xx/xx/xx";
        ArrayList<String> temp = new ArrayList<String>();
        for (String s : data) {
            s = s.trim();
            int index = Integer.valueOf(String.valueOf(s.charAt(s.length() - 2))).intValue();
            if (index == 4) {
                per = s.substring(0, 3) + " ";
            } else if (index == 3) {
                day = s.substring(0, 8) + "-";
            }
            s = day.concat(per.concat(s));
            temp.add(s);
        }
        data = temp;
        temp = null;
        System.out.println("Period Data Appended.");
    }

    public int initializeRegexFeeder() {
        System.out.println("Initialiing Regex Feeder...");
        RegexFeeder rFeed = new RegexFeeder();
        rFeed.addPattern("\\d\\d:\\d\\d.*");  // Get gametrack event 0
        rFeed.addPattern("HOME TEAM:");  // Get Home and Away team names 1
        rFeed.addPattern("VISITORS:");  //Start of visitors roster 2
        rFeed.addPattern("\\d\\d\\D\\d\\d\\D\\d\\d\\s\\d:\\d\\d.*");  // Get Time and location info 3
        rFeed.addPattern("PERIOD Play-by-Play"); // Get Period information 4
        rFeed.addPattern("\\d\\d\\s[A-Z][a-z]");  // Get players 5
        rFeed.addPattern("<"); // Remove Pattern 6
        rFeed.transferPatterns();
        ArrayList<String> temp = new ArrayList<String>();
        for (String s : data) {
            rFeed.matchThrow(rFeed.matchThrow(s), Pattern.compile("~\\d~"), temp);
        }
        data = temp;
        temp = null;
        System.out.println("Regex Feeder Operational.");
        return rFeed.pList.size();
    }

    public ArrayList<String> initializeRegexFeeder(ArrayList<String> list) {
        System.out.println("Initializing Regex Feeder...");
        RegexFeeder rFeed = new RegexFeeder();
        rFeed.addPattern("\\d\\d:\\d\\d.*");  // Get gametrack event 0
        rFeed.addPattern("HOME TEAM:");  // Get Home and Away team names 1
        rFeed.addPattern("VISITORS:");  //Start of visitors roster 2
        rFeed.addPattern("\\d\\d\\D\\d\\d\\D\\d\\d\\s\\d:\\d\\d.*");  // Get Time and location info 3
        rFeed.addPattern("PERIOD Play-by-Play"); // Get Period information 4
        rFeed.addPattern("\\d\\d\\s[A-Z][a-z]");  // Get players 5
        rFeed.addPattern("<"); // Remove Pattern 6
        rFeed.transferPatterns();
        ArrayList<String> temp = new ArrayList<String>();
        for (String s : list) {
            rFeed.matchThrow(rFeed.matchThrow(s), Pattern.compile("~\\d~"), temp);
        }
        list = temp;
        temp = null;
        System.out.println("Regex Feeder Operational.");
        return list;
    }

    public ArrayList<ArrayList<String>> splitOn(int size, ArrayList<String> list) {
        ArrayList<ArrayList<String>> category = new ArrayList<ArrayList<String>>();
        for (int i = 0; i < size; i++) {
            category.add(new ArrayList<String>());
        }
        for (String s : list) {
            s = s.trim();
            int index = Integer.valueOf(String.valueOf(s.charAt(s.length() - 2))).intValue();
            category.get(index).add(s);
        }
        return category;
    }

    public void removeBlock() {
        removeOn("~6~", data);
    }

    public static void printArrayList(ArrayList<String> list) {
        for (String s : list) {
            System.out.println(s);
        }
    }

    public ArrayList<String[]> chopGameTrack() {
        ArrayList<String[]> list = new ArrayList<String[]>();
        for (String s : data) {
            s = s.trim();
            int index = Integer.valueOf(String.valueOf(s.charAt(s.length() - 2))).intValue();
            if (index == 0) {
                list.add(s.split("\\s"));
            }
        }
        return list;
    }

    public ArrayList<String[]> rotateGameTrack(ArrayList<String[]> list) {
        Pattern pattern = Pattern.compile("\\d\\d:\\d\\d");
        ArrayList<String[]> result = new ArrayList<String[]>();
        for (int i = 0; i < list.size(); i++) {
            for (int j = 0; j < list.get(i).length; j++) {
                Matcher matcher = pattern.matcher(list.get(i)[j]);
                while (matcher.find()) {
                    String[] fin;
                    if (list.get(i)[j].length() == 4) {
                        String[] meta = list.get(i)[j].split("-");
                        fin = new String[meta.length + list.get(i).length - 1];
                        System.arraycopy(meta, 0, fin, 0, meta.length); // System array copy
                        int var = list.get(i).length;
                        for (int z = meta.length; z < fin.length; z++) {
                            fin[z] = list.get(i)[var++];
                        }
                    } else {
                        String b = list.get(i)[0];
                        String[] meta = b.split("-");
                        fin = new String[list.get(i).length + meta.length];
                        fin[0] = list.get(i)[j];
                        System.arraycopy(meta, 1, fin, 1, meta.length - 1); //System array copy
                        int var = 1;
                        for (int m = (meta.length + 1); m < fin.length; m++) {
                            fin[m] = list.get(i)[var++];
                        }
                    }
                    result.add(fin);
                }
            }
        }
        return result;
    }

    public String[] meta(String input) {
        String[] result = input.split(" ");
        return result[0].split("-", 2);
    }

    public String eventTime(String input) {
        String[] result = input.split(" ");
        Pattern pattern = Pattern.compile("\\d\\d:\\d\\d");
        for (String s : result) {
            Matcher matcher = pattern.matcher(s);
            while (matcher.find()) {
                return s;
            }
        }
        return input;
    }

    public void addDatesToMatchups() {
        String dateString = "XX/XX/XX ";
        for (int i = 0; i < data.size(); i++) {
            String currentString = data.get(i).trim();
            if (currentString != null && currentString.length() > 3 && currentString.endsWith("~3~")) {
                dateString = currentString.substring(0, 9);
            }
            currentString = dateString.concat(currentString);
            data.set(i, currentString);
        }
    }

    public ArrayList<Game> getGames() {
        ArrayList<Game> gameList = new ArrayList<Game>();
        for (int i = 0; i < data.size(); i++) {
            boolean found = false;
            String homeTeamName = "";
            String awayTeamName = "";
            String currentDate = "xx/xx/xx";
            String currentString = data.get(i).trim();
            if (currentString.trim().endsWith("~1~  ~2~")) {
                continue;
            }
            if (currentString != null && currentString.length() > 3 && currentString.endsWith("~1~")) {
                currentDate = currentString.substring(0, 8);
                System.out.println(currentDate);
                String[] homeTeam = currentString.substring(20).split(" ");
                for (String s : homeTeam) {
                    if (s.matches("\\d.*")) {
                        break;
                    }
                    homeTeamName = homeTeamName + s;
                    homeTeamName = homeTeamName + " ";
                }
                homeTeamName = homeTeamName.trim();
                System.out.println(homeTeamName);
                for(int x = 0; x < gameList.size(); x++) {
                    if(gameList.get(x).gameDate.compareTo(currentDate) == 0) {
                        Game g = gameList.get(x);
                        if(currentDate.compareTo("12/09/11") == 0 && g.homeName != null) {
                            Game z = new Game(homeTeamName, null, currentDate);
                            gameList.add(z);
                        }
                        g.homeName = homeTeamName;
                        gameList.set(x, g);
                        found = true;
                    }
                }
                if(!found) {
                    Game g = new Game(homeTeamName, null, currentDate);
                    gameList.add(g);
                }
            } else if (currentString != null && currentString.length() > 3 && currentString.endsWith("~2~")) {
                currentDate = currentString.substring(0, 8);
                System.out.println(currentDate);
                String[] awayTeam = currentString.substring(19).split(" ");
                for (String s : awayTeam) {
                    if (s.matches("\\d.*")) {
                        break;
                    }
                    awayTeamName = awayTeamName + s;
                    awayTeamName = awayTeamName + " ";
                }
                awayTeamName = awayTeamName.trim();
                System.out.println(awayTeamName);
                for(int x = 0; x < gameList.size(); x++) {
                    if(gameList.get(x).gameDate.compareTo(currentDate) == 0) {
                        Game g = gameList.get(x);
                        if(currentDate.compareTo("12/09/11") == 0 && g.awayName != null) {
                            Game z = new Game(null, awayTeamName, currentDate);
                            gameList.add(z);
                        }
                        g.awayName = awayTeamName;
                        gameList.set(x, g);
                        found = true;
                    }
                }
                if(!found) {
                    Game g = new Game(null, awayTeamName, currentDate);
                    gameList.add(g);
                }
            }            
        }
        return gameList;
    }

    public static void main(String[] args) {
        Parser p = new Parser();
        p.refreshData();
        p.initializeInputFeeder();
        p.initializeRegexFeeder();
        p.removeBlock();
        p.addDatesToMatchups();
        Parser.printArrayList(p.data);
        ArrayList<Game> g = p.getGames();
        System.out.println(g.size());
        for (Game z : g) {
            System.out.println(z.gameDate + " " + z.homeName + " " + z.awayName);
        }
    }
}
