/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package simple_input;

import input_functions.*;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author Greg
 */
public class ETLManager {

    public static ArrayList<String> gameList;
    public static ArrayList<String> homeEvents;
    public static ArrayList<String> awayEvents;
    public static ArrayList<ArrayList<String>> homeReturn;
    public static ArrayList<ArrayList<String>> awayReturn;
    public static Parser parser;
    public static EventTime gameInfo;
    public static final int TRACKLENGTH = 53;

    public static void initializeETLManager() {
        try {
            gameList = InputFeeder.readIn("CurrentGameIn.txt");
        } catch (Exception ex) {
            Logger.getLogger(ETLManager.class.getName()).log(Level.SEVERE, null, ex);
        }
        homeEvents = new ArrayList<String>();
        awayEvents = new ArrayList<String>();
        parser = new Parser();
        homeReturn = new ArrayList<ArrayList<String>>();
        awayReturn = new ArrayList<ArrayList<String>>();
    }

    public static void getEvents() {
        Pattern pattern = Pattern.compile("(\\d\\d:\\d\\d).*");
        for (String s : gameList) {
            Matcher matcher = pattern.matcher(s);
            if (matcher.matches()) {
                awayEvents.add(s);
            } else if (s.length() == TRACKLENGTH) {
                homeEvents.add(s);
            } else {
                homeEvents.add(s.substring(0, TRACKLENGTH));
                matcher = pattern.matcher(s.substring(TRACKLENGTH - 1));
                if (s.substring(TRACKLENGTH - 1).length() >= 30 && matcher.matches()) {
                    awayEvents.add(s.substring(TRACKLENGTH - 1));
                }
            }
        }
    }

    public static ArrayList<String> getTimes(ArrayList<String> list) {
        ArrayList<String> resultConstruct = new ArrayList<String>();
        Pattern pattern = Pattern.compile("(\\d\\d:\\d\\d).*");
        for (String s : list) {
            Matcher matcher = pattern.matcher(s);
            String result = "";
            while (matcher.find()) {
                result = matcher.group(1);
            }
            resultConstruct.add(result);
        }
        return resultConstruct;
    }
    
    public static ArrayList<String> absoluteTimes(ArrayList<String> list, int otPeriods) {
        otPeriods *= 5;
        int currentInteger, pastInteger;
        currentInteger = pastInteger = 40;
        for(int i = 0; i < list.size(); i++) {
            currentInteger = Integer.valueOf(list.get(i).substring(0,2));
            if(currentInteger > pastInteger) {
                for(int j = 0; j < i; j++) {
                    Integer current = Integer.valueOf(list.get(j).substring(0,2));
                    int newValue = current.intValue() + otPeriods + 20;
                    String value = list.get(j);
                    list.set(j, String.valueOf(newValue).concat(value.substring(2)));
                }
            }  
            pastInteger = currentInteger;
        }
        return list;
    }
    
    //work in progress
    public static ArrayList<String> replaceWithAbsoluteTimes(ArrayList<String> fullList, ArrayList<String> timeList) {
        int index = 0;
        Pattern pattern = Pattern.compile("(\\d\\d:\\d\\d).*");
        for(int i = 0; i < fullList.size(); i++) {
            String current = fullList.get(i);
            Matcher matcher = pattern.matcher(current);
            if(matcher.matches()) {
                current = current.replaceAll("\\d\\d:\\d\\d", timeList.get(index++));
                fullList.set(i, current);
            }
            fullList.set(i, current);
        }
        return fullList;
    }

    public static void main(String[] args) {
        ETLManager.initializeETLManager();
        ETLManager.getEvents();
        ArrayList<String> x = ETLManager.getTimes(homeEvents);
        x = ETLManager.absoluteTimes(x, 0);
        x = ETLManager.replaceWithAbsoluteTimes(gameList, x);
        for(String s : x) {
            System.out.println(s);
        }
    }
}
